scala.tools.nsc.Global

# explicitOuter

###
Related Doc: package Global

#### object explicitOuter extends ExplicitOuter

Source
  Global.scala

Linear Supertypes
ExplicitOuter, TreeDSL, TypingTransformers, InfoTransform, Transform, SubComponent, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. explicitOuter
2. ExplicitOuter
3. TreeDSL
4. TypingTransformers
5. InfoTransform
6. Transform
7. SubComponent
8. AnyRef
9. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ExplicitOuterTransformer extends OuterPathTransformer

   The phase performs the following transformations on terms:

   The phase performs the following transformations on terms:

   -

   An class which is not an interface and is not static gets an outer accessor (@see outerDefs).

   1a. A class which is not a trait gets an outer field.

   - A constructor of a non-trait inner class gets an outer parameter.

   - A reference C.this where C refers to an outer class is replaced by a selection this.$outer$$C1 ... .$outer$$Cn (@see outerPath)

   -

   - A call to a constructor Q.<init>(args) or Q.$init$(args) where Q != this and the constructor belongs to a non-static class is augmented by an outer argument. E.g. Q.<init>(OUTER, args) where OUTER is the qualifier corresponding to the singleton type Q.

   - A call to a constructor this.<init>(args) in a secondary constructor is augmented to this.<init>(OUTER, args) where OUTER is the last parameter of the secondary constructor.

   - Remove private modifier from class members M that are accessed from an inner class.

   - Remove protected modifier from class members M that are accessed without a super qualifier accessed from an inner class or trait.

   - Remove private and protected modifiers from type symbols

   - Remove private modifiers from members of traits

   Note: The whole transform is run in phase explicitOuter.next.

   Definition Classes
     ExplicitOuter

2. #### abstract class OuterPathTransformer extends TypingTransformer with Global.UnderConstructionTransformer

   A base class for transformers that maintain outerParam values for outer parameters of constructors.

   A base class for transformers that maintain outerParam values for outer parameters of constructors. The class provides methods for referencing via outer.

   Definition Classes
     ExplicitOuter

3. #### class Phase extends ExplicitOuter.Phase

   Definition Classes
     ExplicitOuter

4. #### class RemoveBindingsTransformer extends Global.Transformer

   Definition Classes
     ExplicitOuter

5. #### abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent

6. #### abstract class TypingTransformer extends Global.Transformer

   Definition Classes
     TypingTransformers

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### object CODE

   Definition Classes
     TreeDSL

5. #### final def afterOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### final def beforeOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

8. #### def changesBaseClasses: Boolean

   This class does not change linearization

   This class does not change linearization

   Definition Classes
     ExplicitOuter → InfoTransform

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

11. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

12. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

13. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

14. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

15. #### val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      explicitOuter → TreeDSL → TypingTransformers → SubComponent

16. #### def hasOuterField(clazz: Global.Symbol): Boolean

    Does given clazz define an outer field?

    Does given clazz define an outer field?

    Definition Classes
      ExplicitOuter

17. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

18. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

19. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### def keepsTypeParams: Boolean

    Attributes
      protected
    Definition Classes
      InfoTransform

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def newOuterAccessor(clazz: Global.Symbol): Global.MethodSymbol

    Definition Classes
      ExplicitOuter

24. #### def newOuterField(clazz: Global.Symbol): Global.TermSymbol

    Definition Classes
      ExplicitOuter

25. #### def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      ExplicitOuter → InfoTransform → Transform → SubComponent

26. #### def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Attributes
      protected
    Definition Classes
      ExplicitOuter → Transform

27. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

29. #### def outerAccessor(clazz: Global.Symbol): Global.Symbol

    Definition Classes
      ExplicitOuter

30. #### def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

31. #### val phaseName: String

    the name of the phase:

    the name of the phase:

    Definition Classes
      ExplicitOuter → SubComponent

32. #### def phaseNewFlags: Long

    The following flags may be set by this phase:

    The following flags may be set by this phase:

    Definition Classes
      ExplicitOuter → SubComponent

33. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

34. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

35. #### val runsAfter: collection.immutable.List[String]

    Names of phases that must run before this phase.

    Names of phases that must run before this phase.

    Definition Classes
      explicitOuter → SubComponent

36. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

37. #### val runsRightAfter: None.type

    Name of the phase that this phase must follow immediately.

    Name of the phase that this phase must follow immediately.

    Definition Classes
      explicitOuter → SubComponent

38. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

39. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

40. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

41. #### def transformInfo(sym: Global.Symbol, tp: Global.Type): Global.Type

    The type transformation method:

    The type transformation method:

    - Add an outer parameter to the formal parameters of a constructor in an inner non-trait class;

    - Add a protected $outer field to an inner class which is not a trait.

    -

    Add an outer accessor $outer$$C to every inner class with fully qualified name C that is not an interface. The outer accessor is abstract for traits, concrete for other classes.

    3a. Also add overriding accessor defs to every class that inherits mixin classes with outer accessor defs (unless the superclass already inherits the same mixin).

    - Make all super accessors and modules in traits non-private, mangling their names.

    - Remove protected flag from all members of traits.

    Note: this transformInfo need not be reflected as the JVM reflection already elides outer pointers.

    Definition Classes
      ExplicitOuter → InfoTransform

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ExplicitOuter

### Inherited from TreeDSL

### Inherited from TypingTransformers

### Inherited from InfoTransform

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped